//+------------------------------------------------------------------+
//|                                                       qwerty.mq4 |
//|                      Copyright  2012, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+

/*   : 
 RSI          N ,   = "0",      = "1". 
,   , -   , ..  "0"    ...*/

#property copyright "Copyright  2012, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 1 

extern int Per = 6;       //  RSI
extern int RSI_Price = 6; //  :0-Close; 1-Open; 2-High; 3-Low; 4-"high+low)/2"; 5-"(H+L+C)/3"; 6-"(H+L+C+C)/4". 
extern int up = 70;       //    RSI
extern int dn = 30;       //    RSI
extern int N = 6;         //     /  

double Buffer[];

int init()
{ SetIndexStyle(0,DRAW_NONE);  SetIndexBuffer(0,Buffer);  SetIndexLabel(0,"Sign"); 
  return(0);
}

int start()
{ int counted_bars=IndicatorCounted();
  if (Bars <= Per+11) return(0);  if (counted_bars > 0) counted_bars--; int limit = Bars-counted_bars; 

  for (int i=0; i<limit; i++)
  { double a = iRSI( NULL,0,Per,RSI_Price,i); 
    double b = iRSI( NULL,0,Per,RSI_Price,i+1);

    double Sign=1; 

    int count = 0; 
    if ((a>up) || (a<dn) || (b>up && a<up) || (b<dn && a>dn))
     { for (int j=0; j<=N; j++)
       {  double R=iRSI(NULL,0,Per,RSI_Price,j);
          if((R>up)||(R<dn)) count++; 
       }
       if (count>N) Sign=0; 
     } 
   Buffer[i] = Sign;
  }
   return(0);
}

